CFINGERD 1.4.3 09/29/99
  - Security update, fixes buffer overflows introduced with sscanf(),
    exploitable under FreeBSD

CFINGERD 1.4.2 09/05/99
  - Bugfix release
  - Corrected build system for FreeBSD, thank Alexey

CFINGERD 1.4.1 08/29/99
  - Path for cfingerd.conf is now configurable via --conf= (Configure)
  - Corrected read code
  - Disabled DAEMON_MODE again
  - Max. 10MB of output will be used from external programs
  - If nobody's logged in, that's displayed, instead of a header.
  - Support for FreeBSD

CFINGERD 1.4.0 08/09/99
  - New source maintainer
  - Several bugfixes
  - Use tail +2 for userlist
  - Fixed silly bug in src/search.c
  - src/search.c: If the internal search.*@ is used the whole GCOS
    field won't be sent out anymore. 
  - Fixed string bugs in standard.c.
  - Ignore empty lines when collecting remote data
  - Flagged SIGPIPE as fatal
  - Corrected logfile writing as user, thanks to Thomas Gebhardt
  - Corrected search_fake() which depended on 80 char strings but
    received a 100 character one. (most recent on bugtraq, fixed on
    12 May 1998)
  - Corrected RFC1413 code
  - Corrected check_illegal() for .nofinger
  - Corrected wrong calls for check_illegal()
  - Fixed a security hole in privs.h.
  - Fixed typo in userlist/display.c which crashed userlist
  - Proper exception if ident doesn't provide useful info
  - Added patch to support Qmail mailboxes, thanks to Russell Coker
  - Removed investigation of the hostname within Configure script
  - src/main.c: Added support for /W, actually it's ignored...
  - Added define HAVE_TTY_GROUP so add support for non-world-writable
    tty's owned by group tty
  - Used config option for .nofinger file instad of static ".nofinger"
  - Added space before [MSG-N]
  - Reworked search.* routine.
  - Documentation update
  - Restricted length of username, fixes possible overflow in
    show_search() and handle_fakeuser()
  - Converted all dangerous occurrances of strcpy() to strncpy()
  - More updates wrt. sane permissions when opening files
  - Increased limit of tty per user, now I'm fingerable again. :)
  - cfingerd now uses the same IP number on which it receives a request to
    connect to a remote ident server.  Thanks for help from Torsten
    Landschoff
  - cfingerd now honors broken or negative ident answers
  - Support for SunOS by Piotr Klaban <makler@man.torun.pl>
  - Support 24h clocks, inspired by Piotr Klaban
  - Removed ACTUAL_HOSTNAME since it has been superseeded by calls to
    gethostname()
  - Experimental code for standalone cfingerd, inspired by Piotr Klaban
  - Fixed userlist that crashed at too many users and too long hostnames
  - Fixed non-working userlist-only
  - Added ALLOW_CONFESSION to provide "help" and "version" information
  - Added support for userlist@ (and userlist-online@ internally) as
    modification of @ (system list) that displays only non-idle users.
  - Fixed security bug that caused external programs to gain root access.
  - Adjusted search facility, you can't get a userlisting anymore

CFINGERD 1.3.2 12/17/96
  - Added two new options: ONLY_SHOW_HEADERS_IF_FILE_EXISTS, and
    ONLY_CREATE_FINGERLOG_IF_FILE_EXISTS (see man pages for more details)
  - Fixed fakeuser (and other) entries to allow commenting at the beginning
    of each entry line if they want to be commented out
  - Fixed check_illegal routine to use lstat instead of its old method
  - Updated the FAQ, README, and other supporting documentation
  - Updated cfingerd.conf documentation for the MAILBOX addition
  - Made minor cosmetic changes to Configure and Install

CFINGERD 1.3.1 09/20/96
  - Updated the Configure script and supporting libraries to make it
    compatible with Perl 4.036
  - Added support for ignoring the "/W or -L" options that some fingers send
  - Added "MAILBOX" entry to display_files section of cfingerd.conf
  - Added replacement strings for RFC1413 error related messages
  - Added safe_exec routine to run *ALL* programs via popen with nobody privs
    (see the util.c source)
  - Added checks to make sure *everything* is run as root after a file open,
    or other file activity
  - Changed file handles to open files as root (READ-ONLY) and have them read
    from the open file handle as "nobody"
  - Changed redirection of executed files to no redirection (no writing to
    any files on execution)
  - Changed "There are (users) total" to "This is a list of (total) sites"
  - Changed up the Makefiles a little bit to run smoother

CFINGERD 1.3.0 08/03/96
  - Updated the configuration script some more
  - Made some fixes to the userlist program (clearing initial variables)
  - Made some major upgrades in source (uses "-" to hide hidden fakeusers)
  - Fixed show_file routines to show files owned by "user"

CFINGERD 1.2.3 07/28/96  ** YEAR ANIVERSARY FOR CFINGERD **
  - Fixed up the Configuration file to check for a Clean makefile
  - Fixed up the FAQ (updated to version 0.5 now)
  - Fixed search list from a limit of 100 entries to 500 entries (will soon 
    make it a linked list)
  - Fixed userlist to show correct display with PRIV_ROOT_START/END macros
  - Added patches to source from "Stig" (stig@hackvan.com)
  - Added security breach finger check for "search.*"
  - Added more secure become_nobody macros
  - Removed become_nobody and become_user routines
  - Changed Install script to say "1.2.x" instead of "1.2.0"
  - Updated the FAQ

CFINGERD 1.2.2 05/13/96
  - Added XFACE option to cfingerd (to display an .xface line if present)
  - Added "XFACE" and "NO_XFACE" options to cfingerd.conf and to display routines
  - Fixed finger-forward recursion bug (thanks to Larry Daffner)
  - Added patches to ident/auth, and lastlog
  - Added patches to main, userlist, and some others based on Michael Jarvis'
    advise and opinions
  - Added Kevin Rosenberg's BSD patches
  - Added LICENSE file to make CFINGERD officially GPL'ed
  - Added the license information to each source file that was applicable
  - Removed the lastlog.h file
  - Updated the FAQ and supporting README file

CFINGERD 1.2.1 03/15/96
  - Added error reporting to configuration file
  - Added usage of space instead of tab in configuration file indentions
  - Added replacements for options in case the sysadmin keeps them blank
    (in the cfingerd.conf file)
  - Added HAS_SHADOW option to config.h
  - Added a new lastlog.h file for Shadow compatibility
  - Added ALLOW_FAKEUSER_FINGER option to turn on or off fakeuser ability
  - Added documentation on ALLOW_USERLOG (forgot to add it ... oops)
  - Updated documentation (cfingerd.conf.5 man page)
  - Fixed userlist to actually work now
  - Fixed Configure script to accept a specified domain name
  - Changed root.wheel to root.root on the userlist installation Makefile

CFINGERD 1.2.0 02/19/96
  - Added a log item when an illegal user was fingered
  - Added automatic check for domain name (thanks to Linus Torvald's Makefile)
  - Added comments to Makefiles to give a little more verbose input
  - Added scripting commands to any text files (see cfingerd.script.5)
  - Added cfingerd.text.5 manual page describing text commands
  - Added trusted and rejected checking of IP addresses now
  - Added "make instdocs" option to force (re)installation of cfingerd docs
  - Added userlog files for users to keep track of who fingers them
  - Added "ALLOW_EXECUTION" option for executable programs within display files
  - Added "WTMP_FILE" define to change the WTMP file that is used
  - Added lastlog parsing routine to speed up last login information by 1000%
  - Updated some formatting problems in finger output
  - Fixed a bug with "IF_ONLINE" displaying info even if it's set to FALSE
  - Changed .project, .plan, and .pgp to show files via the element parser
  - Changed Configure to auto-find /var/adm/wtmp or /var/adm/lastlog
  - Changed order of PROJECT/PLAN file display in standard.c

CFINGERD 1.1.1 01/04/96
  - Added ident information to logging
  - Added 5 second alarm timeout in rfc1413 routine, and a return of
    "unknown@alarm.signal" if an alarm was caught
  - Fixed userlist routine to show specialized header only if userlist is used
  - Fixed a log bug with normal user fingers
  - Fixed a log configuration and display bug (reported by Kevin Rosenberg)
  - Created a FAQ (started one, at least)
  - Changed user finger display to show the ident data when a user fingers 
    another user on your system
  - Changed rfc1413 routine to return unknown@user.site.here if any part of
    the rfc1413 fails (all except for an alarm.)  (Thanks to Andrew Smith)
  - Officially released

CFINGERD 1.1.1B4 12/30/95
  - Fixed up the rfc1413 routine to run about 50% faster
  - Added logging and logfile definition for logs of any errors or actions

CFINGERD 1.1.1B3 12/29/95
  - Added wildcard host matching thanks to Rich $alz
  - Added wildcard matching in the user search routines
  - Added RFC1413 implementation for ident authentication
  - Added "No realname field available" if no realname field is available when
    displaying a search
  - Added rejection of fingers (configurable) if ident reports "unknown"
  - Fixed a bug in search routine where multiple appearances of the same user-
    name would appear - I failed to use bzero...  :/

CFINGERD 1.1.1B2 12/10/95
  - Fixed a bug that displayed "root" fingered if a user with 4 characters was
    fingered.  (Thanks to Jon Mitchell)

CFINGERD 1.1.1B1 12/01/95
  - Added some changes in the Configuration script to make it more compatible

CFINGERD 1.1.1A2 11/23/95
  - Added Kevin Rosenberg's patches for BSD/OS compilation
  - Fixed some stupid bugs (mistypings on my part) to fix Kevin's fixes...  :)

CFINGERD 1.1.1A1 11/20/95
  - Added "ALLOW_FINGER_FORWARDING" option in cfingerd.conf
  - Added "HOSTS finger_forward" option in cfingerd.conf
  - Added "ALLOW_USERLIST_ONLY" option in cfingerd.conf (was a security hole)
  - Fixed Install script to force copy in.cfingerd at the end
  - Added multiple site forwarding (from the forward option)
  - Added change so that nice actually changes priority of the program now

CFINGERD 1.1.0 11/20/95
  - Officially released to the public as 1.1.0 - the new, spiffy version

CFINGERD 1.1.0B5 11/19/95
  - Fixed a bug in userlist routine so it now shows the no-name user banner
  - Made slight rewording changes in the Configure script
  - Added comments to each routine

CFINGERD 1.1.0B4 10/01/95
  - Fixed checksite routine to actually work this time
  - Fixed userlist routine to work correctly (was showing invalid idletimes)
  - Updated makefiles and moved source to src directory
  - Updated documentation

CFINGERD 1.1.0B3 08/26/95
  - Touched up some formatting problems
  - Touched up the documentation a bit
  - Removed wildcard checking
  - Removed all occurances of wildcards in all code
  - Fixed userlist to run as root (was causing problems running as nobody)
  - Fixed finger routines to switch to UID/GID of fingering user instead of
    becoming nobody
  - Fixed userlist to actually use the "FINGER" option when requesting a
    userlist
  - Fixed userlist to cut off all string delimiters in utmp routines
  - Fixed up some scripts to work a little nicer (and more configurable)

CFINGERD 1.1.0B2 08/26/95
  - Touched up the manual pages a bit
  - Took out the entire "config" directory
  - Fixed file stat reporting from using stat to using ls -al (reported by
    David Storey)
  - Fixed all files to go through the stat check (especially .files)
  - Added a check for config.h in Makefile
  - Added Install script
  - Added "become_nobody" routine to change to the nobody UID/GID for security
    purposes

CFINGERD 1.1.0B1 08/13/95
  - Took out "ERRORS" variable in errors.c
  - Made options in cfingerd.conf no longer case sensitive
  - Optimized a little bit of the main code, removed case sensitivity in
    site names
  - Fixed showing "User has no mail" if the user has no mail spool
  - Fixed "other" field so that garbage no longer appears

  -- SWITCHED TO BETA ON 08/13/95 --

CFINGERD 1.1.0A12 08/13/95
  - Changed PGP Key standard from ".pgp" to ".pgpkey" based on a betatester's
    devine observation
  - Changed configure.c so it uses structures to hold info instead of typing
    everything in manually - made the size drop about 10K
  - Added check for SHOW_WILDCARD
  - Added check for SHOW_MULTFING, and added nicer spaced formatting in the
    userlist display routines
  - Added check for SHOW_SEARCHFING
  - Added check for SHOW_IP_MATCH
  - Added sanity check on startup (clear out all structures)

CFINGERD 1.1.0A11 08/13/95
  - Fixed a bug that wouldn't show if a user never logged in - now shows
    correctly (Thanks to a betatester .. again!)
  - Fixed a bug that showed "file is a directory" if the file doesn't exist
    or stat returns EBADF or ENOENT
  - Fixed up the Configure script so it doesn't use "hostname --fqdn" anymore
  - Fixed up the Makefile for both cfingerd and userlist
  - Added an option to show PGPKEYs (Thanks to Andrew Smith)
  - Added cfingerd.5 manual page
  - Added cfingerd.conf.5 manual page
  - Added userlist/userlist.1 manual page
  - Added more verbose error reporting in configure.c
  - Added allowance for "," character in fingering
  - Added "trace" script to the installable scripts

CFINGERD 1.1.0A10 08/08/95
  - Fixed a bug in search routines (when reading /etc/passwd)
  - Fixed some bugs in search routines pertaining to load
  - Fixed search routine so that they can't do a search for a blank
  - Fixed a bug when doing emulated local fingers from the command line - would
    display garbage in the syslog
  - Fixed configure module to actually load in the new signal_strings
  - Changed Configure script to get the fully qualified domain name with the
    command "hostname --fqdn"
  - Added PID display in syslogging display
  - Added case insensitive searching in the search routines
  - Added a check to standard displaying so that a sneaky user can't create
    a strange file (ie. block device, socket, symbolic link, fifo, dir, or
    char device - only a readable file)
  - Added syslogging if any illegal .nofinger files are detected during a finger
  - Added "[MSG-N]" display if messages are turned off on that console

CFINGERD 1.1.0A9 08/07/95
  - Changed signal routine to use loaded signal strings instead of pre-made ones
  - Removed "%" from search standard - too wacky; changed to "." instead
  - Added CONFIG signal_strings section to cfingerd.conf
  - Added (and checked) all user-defined syslog messages
  - Added searchable finger routine to give nice output on search results 
    (fully tested - it works.  REALLY!)

CFINGERD 1.1.0A8 08/07/95
  - Fixed a bug with junk displayed in the "last seen" display
  - Fixed formatting in userlist display a little
  - Fixed user-listings between sites to use userlist-only finger
  - Fixed a looping problem with fingering for sorted userlists (BIG problem)
  - Fixed output from fakeuser if too many options are given (beautified)
  - Added Configure script
  - Added "has unread mail since" display (per suggestion from a betatester)
  - Added trusted hosts and trusted host display in syslog
  - Added rejected hosts, rejected host display in syslog, and rejected file
    display
  - Added "userlist-only" for only listing userlists (in gathering userlists
    between machines and sites)

CFINGERD 1.1.0A7 08/05/95
  - Fixed a bug that made mail turn to "old-mail" state when you were fingered
    and had new mail.  (Now uses the stat structure - wasn't quite fixed in
    A6 either!)
  - Fixed a bug that display junk after login names
  - Fixed a bug in display formatting with ALLOW_STRICT_FORMATTING enabled
  - Added idle time display in both cfingerd and in the userlist
  - Added ALLOW_VERBOSE_TIMESTAMPING for verbose idle time display (using
    words instead of numbers alone)
  - Added syslogging (minimal) display support ... more later
  - Added examples in the userlist directory for future use

CFINGERD 1.1.0A6 08/03/95
  - Added ALLOW_STRICT_FORMATTING to make formatting more like SysV.  :)
  - Fixed the routine to show whether or not a user has mail (wasn't quite
    fixed in A5...)

CFINGERD 1.1.0A5 07/31/95
  - Removed AUTH_* identifiers ... no need for 'em anymore
  - Added fakeuser stuff
  - Made userlist now exclude any users that have a ".nofinger" file in their
    home directory (Tested - it works.)
  - Added support to display user services lists
  - Fixed a bug that reports if a user has mail (checking a FILE struct instead
    of an int struct...)
  - Added a wildcard routine that only supports the "?" wildcard so far

CFINGERD 1.1.0A4 07/28/95
  - Added .nofinger display routine
  - Changed the userlist finger display a little so it looks better and now
    has a header...
  - Completed the userlist program ... all that remains is the idle time.  :)
  - Added command line options to userlist (not yet functional except -c!)

CFINGERD 1.1.0A3 - CFINGERD 1.1.0A0
  - UNDOCUMENTED CHANGES (oops)
